libvisio Namespace Reference documentation

Classes | Typedefs | Enumerations | Functions | Variables
libvisio Namespace Reference

## Classes
struct | ChunkHeader
struct | Colour
class | EndOfStreamException
struct | ForeignData
class | GenericException
struct | NURBSData
struct | Pointer
struct | PolylineData
class | VDXParser
class | VisioDocument
class | VSD5Parser
class | VSD6Parser
class | VSDArcTo
struct | VSDBullet
class | VSDCharacterList
class | VSDCharacterListElement
class | VSDCharIX
struct | VSDCharStyle
class | VSDCloseListElementOutputElement
class | VSDCloseParagraphOutputElement
class | VSDCloseSpanOutputElement
class | VSDCloseUnorderedListLevelOutputElement
class | VSDCollector
class | VSDContentCollector
struct | VSDDummyDeleter
class | VSDEllipse
class | VSDEllipticalArcTo
class | VSDEmpty
class | VSDEndLayerOutputElement
class | VSDEndTextObjectOutputElement
class | VSDFieldList
class | VSDFieldListElement
struct | VSDFillStyle
struct | VSDFont
class | VSDGeometry
class | VSDGeometryList
class | VSDGeometryListElement
class | VSDGraphicObjectOutputElement
class | VSDInfiniteLine
class | VSDInsertLineBreakOutputElement
class | VSDInsertTabOutputElement
class | VSDInsertTextOutputElement
struct | VSDLayer
class | VSDLayerList
struct | VSDLineStyle
class | VSDLineTo
class | VSDMetaData
struct | VSDMisc
class | VSDMoveTo
class | VSDName
class | VSDNumericField
class | VSDNURBSTo1
class | VSDNURBSTo2
class | VSDNURBSTo3
class | VSDOpenListElementOutputElement
class | VSDOpenParagraphOutputElement
class | VSDOpenSpanOutputElement
class | VSDOpenUnorderedListLevelOutputElement
struct | VSDOptionalCharStyle
struct | VSDOptionalFillStyle
struct | VSDOptionalLineStyle
struct | VSDOptionalParaStyle
struct | VSDOptionalTextBlockStyle
class | VSDOutputElement
class | VSDOutputElementList
class | VSDPage
class | VSDPages
class | VSDParagraphList
class | VSDParagraphListElement
class | VSDParaIX
struct | VSDParaStyle
class | VSDParser
class | VSDPathOutputElement
class | VSDPolylineTo1
class | VSDPolylineTo2
class | VSDPolylineTo3
class | VSDRelCubBezTo
class | VSDRelEllipticalArcTo
class | VSDRelLineTo
class | VSDRelMoveTo
class | VSDRelQuadBezTo
class | VSDShape
class | VSDShapeList
class | VSDSplineKnot
class | VSDSplineStart
class | VSDStartLayerOutputElement
class | VSDStartTextObjectOutputElement
class | VSDStencil
class | VSDStencils
class | VSDStyleOutputElement
class | VSDStyles
class | VSDStylesCollector
struct | VSDTabSet
struct | VSDTabStop
struct | VSDTextBlockStyle
class | VSDTextField
struct | VSDXClrScheme
struct | VSDXFont
struct | VSDXFontScheme
class | VSDXMetaData
| Parses docProps/core.xml stream of a VSDX file. More...
class | VSDXMLParserBase
class | VSDXMLTokenMap
class | VSDXParser
class | VSDXRelationship
class | VSDXRelationships
class | VSDXTheme
struct | VSDXVariationClrScheme
struct | XForm
struct | XForm1D
class | XMLErrorWatcher
class | XmlParserException

## Typedefs
typedef std::shared_ptr< librevenge::RVNGInputStream > | RVNGInputStreamPtr_t

## Enumerations
enum | TextFormat { VSD_TEXT_ANSI = 0, VSD_TEXT_SYMBOL, VSD_TEXT_GREEK, VSD_TEXT_TURKISH, VSD_TEXT_VIETNAMESE, VSD_TEXT_HEBREW, VSD_TEXT_ARABIC, VSD_TEXT_BALTIC, VSD_TEXT_RUSSIAN, VSD_TEXT_THAI, VSD_TEXT_CENTRAL_EUROPE, VSD_TEXT_JAPANESE, VSD_TEXT_KOREAN, VSD_TEXT_CHINESE_SIMPLIFIED, VSD_TEXT_CHINESE_TRADITIONAL, VSD_TEXT_UTF8, VSD_TEXT_UTF16 }

## Functions
template<typename T , typename... Args>
std::unique_ptr< T > | make_unique (Args &&... args)
template<typename T >
std::unique_ptr< T > | clone (const std::unique_ptr< T > &other)
uint8_t | readU8 (librevenge::RVNGInputStream *input)
uint16_t | readU16 (librevenge::RVNGInputStream *input)
int16_t | readS16 (librevenge::RVNGInputStream *input)
uint32_t | readU32 (librevenge::RVNGInputStream *input)
int32_t | readS32 (librevenge::RVNGInputStream *input)
uint64_t | readU64 (librevenge::RVNGInputStream *input)
double | readDouble (librevenge::RVNGInputStream *input)
const librevenge::RVNGString | getColourString (const Colour &c)
unsigned long | getRemainingLength (librevenge::RVNGInputStream *input)
void | appendUCS4 (librevenge::RVNGString &text, UChar32 ucs4Character)
void | debugPrint (const char *format,...) VSD_ATTRIBUTE_PRINTF(1
std::unique_ptr< xmlTextReader, void(*)(xmlTextReaderPtr)> | xmlReaderForStream (librevenge::RVNGInputStream *input, XMLErrorWatcher *const watcher, bool recover)
Colour | xmlStringToColour (const xmlChar *s)
Colour | xmlStringToColour (const std::shared_ptr< xmlChar > &s)
long | xmlStringToLong (const xmlChar *s)
long | xmlStringToLong (const std::shared_ptr< xmlChar > &s)
double | xmlStringToDouble (const xmlChar *s)
double | xmlStringToDouble (const std::shared_ptr< xmlChar > &s)
bool | xmlStringToBool (const xmlChar *s)
bool | xmlStringToBool (const std::shared_ptr< xmlChar > &s)

## Variables
std::unique_ptr< xmlTextReader, void(*)(xmlTextReaderPtr)> | xmlReaderForStream (librevenge::RVNGInputStream *input, XMLErrorWatcher *watcher=nullptr, bool recover=true)

## Typedef Documentation

## ◆ RVNGInputStreamPtr_t

typedef std::shared_ptr<librevenge::RVNGInputStream> libvisio::RVNGInputStreamPtr_t

## Enumeration Type Documentation

## ◆ TextFormat

enum libvisio::TextFormat

Enumerator
VSD_TEXT_ANSI |
VSD_TEXT_SYMBOL |
VSD_TEXT_GREEK |
VSD_TEXT_TURKISH |
VSD_TEXT_VIETNAMESE |
VSD_TEXT_HEBREW |
VSD_TEXT_ARABIC |
VSD_TEXT_BALTIC |
VSD_TEXT_RUSSIAN |
VSD_TEXT_THAI |
VSD_TEXT_CENTRAL_EUROPE |
VSD_TEXT_JAPANESE |
VSD_TEXT_KOREAN |
VSD_TEXT_CHINESE_SIMPLIFIED |
VSD_TEXT_CHINESE_TRADITIONAL |
VSD_TEXT_UTF8 |
VSD_TEXT_UTF16 |

## Function Documentation

## ◆ appendUCS4()

void libvisio::appendUCS4 | ( | librevenge::RVNGString & | text,
|  | UChar32 | ucs4Character
| ) |  |

Referenced by libvisio::VSDContentCollector::_bulletFromParaFormat(), libvisio::VSDContentCollector::appendCharacters(), and libvisio::VSDMetaData::readCodePageString().

## ◆ clone()

template<typename T >

std::unique_ptr<T> libvisio::clone | ( | const std::unique_ptr< T > & | other | ) |

Referenced by libvisio::VSDOutputElementList::append(), libvisio::VSDOutputElementList::operator=(), libvisio::VSDParagraphList::operator=(), libvisio::VSDCharacterList::operator=(), libvisio::VSDGeometryList::operator=(), libvisio::VSDFieldList::operator=(), libvisio::VSDCharacterList::VSDCharacterList(), libvisio::VSDFieldList::VSDFieldList(), libvisio::VSDGeometryList::VSDGeometryList(), libvisio::VSDOutputElementList::VSDOutputElementList(), and libvisio::VSDParagraphList::VSDParagraphList().

## ◆ debugPrint()

void libvisio::debugPrint | ( | const char * | format,
|  |  | ...
| ) |  |

## ◆ getColourString()

const librevenge::RVNGString libvisio::getColourString | ( | const Colour & | c | ) |

Referenced by libvisio::VSDContentCollector::_fillAndShadowProperties(), libvisio::VSDContentCollector::_fillCharProperties(), libvisio::VSDContentCollector::_flushText(), and libvisio::VSDContentCollector::_lineProperties().

## ◆ getRemainingLength()

unsigned long libvisio::getRemainingLength | ( | librevenge::RVNGInputStream * | input | ) |

Referenced by libvisio::VSDParser::readCharList(), libvisio::VSDMetaData::readCodePageString(), libvisio::VSDParser::readFieldList(), libvisio::VSDParser::readGeomList(), libvisio::VSDParser::readLayerList(), libvisio::VSD5Parser::readNameIDX(), libvisio::VSDParser::readNameIDX(), libvisio::VSDParser::readParaList(), libvisio::VSDMetaData::readPropertySet(), libvisio::VSDParser::readShapeData(), libvisio::VSDParser::readShapeList(), and libvisio::VSDParser::readTabsDataList().

## ◆ make_unique()

template<typename T , typename... Args>

std::unique_ptr<T> libvisio::make_unique | ( | Args &&... | args | ) |

## ◆ readDouble()

double libvisio::readDouble | ( | librevenge::RVNGInputStream * | input | ) |

Referenced by libvisio::VSDParser::readArcTo(), libvisio::VSD6Parser::readCharIX(), libvisio::VSD5Parser::readCharIX(), libvisio::VSDParser::readCharIX(), libvisio::VSDParser::readEllipse(), libvisio::VSDParser::readEllipticalArcTo(), libvisio::VSDParser::readFillAndShadow(), libvisio::VSDParser::readForeignDataType(), libvisio::VSDParser::readInfiniteLine(), libvisio::VSD5Parser::readLine(), libvisio::VSDParser::readLine(), libvisio::VSDParser::readLineTo(), libvisio::VSDParser::readMoveTo(), libvisio::VSDParser::readNURBSTo(), libvisio::VSDParser::readPageProps(), libvisio::VSD6Parser::readParaIX(), libvisio::VSD5Parser::readParaIX(), libvisio::VSDParser::readParaIX(), libvisio::VSDParser::readPolylineTo(), libvisio::VSDParser::readShapeData(), libvisio::VSDParser::readSplineKnot(), libvisio::VSDParser::readSplineStart(), libvisio::VSDParser::readTabsData(), libvisio::VSD5Parser::readTextBlock(), libvisio::VSDParser::readTextBlock(), libvisio::VSD6Parser::readTextField(), libvisio::VSD5Parser::readTextField(), libvisio::VSDParser::readTextField(), libvisio::VSDParser::readTxtXForm(), libvisio::VSD5Parser::readXForm1D(), libvisio::VSDParser::readXForm1D(), and libvisio::VSDParser::readXFormData().

## ◆ readS16()

int16_t libvisio::readS16 | ( | librevenge::RVNGInputStream * | input | ) |

Referenced by libvisio::VSD5Parser::getInt(), libvisio::VSD5Parser::getUInt(), libvisio::VSD5Parser::readPointerInfo(), and libvisio::VSD5Parser::readTextField().

## ◆ readS32()

int32_t libvisio::readS32 | ( | librevenge::RVNGInputStream * | input | ) |

Referenced by libvisio::VSDParser::getInt(), libvisio::VSDParser::readPointerInfo(), libvisio::VSD6Parser::readTextField(), and libvisio::VSDParser::readTextField().

## ◆ readU16()

uint16_t libvisio::readU16 | ( | librevenge::RVNGInputStream * | input | ) |

Referenced by libvisio::VSD6Parser::getChunkHeader(), libvisio::VSDParser::getChunkHeader(), libvisio::VSD5Parser::handleChunkRecords(), libvisio::VSDMetaData::parseTimes(), libvisio::VSD6Parser::readCharIX(), libvisio::VSD5Parser::readCharIX(), libvisio::VSDParser::readCharIX(), libvisio::VSDParser::readForeignDataType(), libvisio::VSDParser::readName2(), libvisio::VSD5Parser::readNameIDX(), libvisio::VSDParser::readNURBSTo(), libvisio::VSD5Parser::readParaIX(), libvisio::VSDParser::readParaIX(), libvisio::VSD5Parser::readPointer(), libvisio::VSDParser::readPointer(), libvisio::VSDParser::readPolylineTo(), libvisio::VSDMetaData::readPropertySetStream(), readS16(), libvisio::VSDParser::readShapeData(), libvisio::VSD6Parser::readTextField(), libvisio::VSDParser::readTextField(), and libvisio::VSDMetaData::readTypedPropertyValue().

## ◆ readU32()

uint32_t libvisio::readU32 | ( | librevenge::RVNGInputStream * | input | ) |

Referenced by libvisio::VSD6Parser::getChunkHeader(), libvisio::VSD5Parser::getChunkHeader(), libvisio::VSDParser::getChunkHeader(), libvisio::VSDParser::getUInt(), libvisio::VSDParser::handleStreams(), libvisio::VSDMetaData::parseTimes(), libvisio::VSD6Parser::readCharIX(), libvisio::VSDParser::readCharIX(), libvisio::VSDParser::readCharList(), libvisio::VSDMetaData::readCodePageString(), libvisio::VSDParser::readFieldList(), libvisio::VSDParser::readForeignDataType(), libvisio::VSDParser::readGeomList(), libvisio::VSDParser::readLayerList(), libvisio::VSD6Parser::readMisc(), libvisio::VSDParser::readMisc(), libvisio::VSDParser::readNameIDX(), libvisio::VSDParser::readNURBSTo(), libvisio::VSDParser::readPage(), libvisio::VSD6Parser::readParaIX(), libvisio::VSDParser::readParaIX(), libvisio::VSDParser::readParaList(), libvisio::VSD5Parser::readPointer(), libvisio::VSDParser::readPointer(), libvisio::VSDParser::readPointerInfo(), libvisio::VSDParser::readPolylineTo(), libvisio::VSDMetaData::readPropertyIdentifierAndOffset(), libvisio::VSDMetaData::readPropertySet(), libvisio::VSDMetaData::readPropertySetStream(), readS32(), libvisio::VSDParser::readShape(), libvisio::VSDParser::readShapeData(), libvisio::VSDParser::readShapeList(), libvisio::VSDParser::readStyleSheet(), libvisio::VSDParser::readTabsDataList(), libvisio::VSD6Parser::readTextField(), and libvisio::VSDParser::readTextField().

## ◆ readU64()

uint64_t libvisio::readU64 | ( | librevenge::RVNGInputStream * | input | ) |

Referenced by libvisio::VSDMetaData::parseTimes(), and readDouble().

## ◆ readU8()

uint8_t libvisio::readU8 | ( | librevenge::RVNGInputStream * | input | ) |

Referenced by libvisio::VSD6Parser::getChunkHeader(), libvisio::VSD5Parser::getChunkHeader(), libvisio::VSDParser::getChunkHeader(), getRemainingLength(), libvisio::VSD6Parser::readCharIX(), libvisio::VSD5Parser::readCharIX(), libvisio::VSDParser::readCharIX(), libvisio::VSDMetaData::readCodePageString(), libvisio::VSDParser::readColours(), libvisio::VSD6Parser::readFillAndShadow(), libvisio::VSD5Parser::readFillAndShadow(), libvisio::VSDParser::readFillAndShadow(), libvisio::VSDParser::readFont(), libvisio::VSDParser::readFontIX(), libvisio::VSDParser::readGeometry(), libvisio::VSDParser::readLayer(), libvisio::VSD6Parser::readLayerMem(), libvisio::VSDParser::readLayerMem(), libvisio::VSD5Parser::readLine(), libvisio::VSDParser::readLine(), libvisio::VSD6Parser::readMisc(), libvisio::VSD5Parser::readMisc(), libvisio::VSDParser::readMisc(), libvisio::VSD6Parser::readName2(), libvisio::VSDParser::readNURBSTo(), libvisio::VSD6Parser::readParaIX(), libvisio::VSD5Parser::readParaIX(), libvisio::VSDParser::readParaIX(), libvisio::VSDParser::readPolylineTo(), libvisio::VSDMetaData::readPropertySetStream(), libvisio::VSDParser::readShapeData(), libvisio::VSDParser::readSplineStart(), libvisio::VSDParser::readTabsData(), libvisio::VSD5Parser::readTextBlock(), libvisio::VSDParser::readTextBlock(), libvisio::VSD6Parser::readTextField(), libvisio::VSD5Parser::readTextField(), libvisio::VSDParser::readTextField(), and libvisio::VSDParser::readXFormData().

## ◆ xmlReaderForStream()

std::unique_ptr<xmlTextReader, void (*)(xmlTextReaderPtr)> libvisio::xmlReaderForStream | ( | librevenge::RVNGInputStream * | input,
|  | XMLErrorWatcher *const | watcher,
|  | bool | recover
| ) |  |

## ◆ xmlStringToBool() [1/2]

bool libvisio::xmlStringToBool | ( | const xmlChar * | s | ) |

Referenced by libvisio::VSDXMLParserBase::readArcTo(), libvisio::VSDXMLParserBase::readBoolData(), libvisio::VSDXMLParserBase::readEllipse(), libvisio::VSDXMLParserBase::readEllipticalArcTo(), libvisio::VSDXMLParserBase::readGeometry(), libvisio::VSDXMLParserBase::readInfiniteLine(), libvisio::VSDXMLParserBase::readLineTo(), libvisio::VSDXMLParserBase::readMoveTo(), libvisio::VSDXMLParserBase::readNURBSTo(), libvisio::VSDXMLParserBase::readPage(), libvisio::VSDXMLParserBase::readPolylineTo(), libvisio::VSDXMLParserBase::readRelCubBezTo(), libvisio::VSDXMLParserBase::readRelEllipticalArcTo(), libvisio::VSDXMLParserBase::readRelLineTo(), libvisio::VSDXMLParserBase::readRelMoveTo(), libvisio::VSDXMLParserBase::readRelQuadBezTo(), libvisio::VSDXMLParserBase::readSplineKnot(), libvisio::VSDXMLParserBase::readSplineStart(), and xmlStringToBool().

## ◆ xmlStringToBool() [2/2]

bool libvisio::xmlStringToBool | ( | const std::shared_ptr< xmlChar > & | s | ) |

## ◆ xmlStringToColour() [1/2]

Colour libvisio::xmlStringToColour | ( | const xmlChar * | s | ) |

Referenced by libvisio::VSDXMLParserBase::readColours(), libvisio::VSDXMLParserBase::readExtendedColourData(), libvisio::VSDXTheme::readSrgbClr(), libvisio::VSDXTheme::readSysClr(), and xmlStringToColour().

## ◆ xmlStringToColour() [2/2]

Colour libvisio::xmlStringToColour | ( | const std::shared_ptr< xmlChar > & | s | ) |

## ◆ xmlStringToDouble() [1/2]

double libvisio::xmlStringToDouble | ( | const xmlChar * | s | ) |

Referenced by libvisio::VSDXMLParserBase::readDoubleData(), and xmlStringToDouble().

## ◆ xmlStringToDouble() [2/2]

double libvisio::xmlStringToDouble | ( | const std::shared_ptr< xmlChar > & | s | ) |

## ◆ xmlStringToLong() [1/2]

long libvisio::xmlStringToLong | ( | const xmlChar * | s | ) |

Referenced by libvisio::VSDXMLParserBase::getIX(), libvisio::VSDXMLParserBase::readCharIX(), libvisio::VSDXMLParserBase::readExtendedColourData(), libvisio::VDXParser::readFonts(), libvisio::VSDXMLParserBase::readLongData(), libvisio::VSDXMLParserBase::readPage(), libvisio::VSDXMLParserBase::readParaIX(), libvisio::VSDXMLParserBase::readShape(), libvisio::VSDXMLParserBase::readStencil(), libvisio::VSDXMLParserBase::readStyleSheet(), libvisio::VSDXParser::readTabRow(), and xmlStringToLong().

## ◆ xmlStringToLong() [2/2]

long libvisio::xmlStringToLong | ( | const std::shared_ptr< xmlChar > & | s | ) |

## Variable Documentation

## ◆ xmlReaderForStream

std::unique_ptr<xmlTextReader, void (*)(xmlTextReaderPtr)> libvisio::xmlReaderForStream(librevenge::RVNGInputStream *input, XMLErrorWatcher *watcher=nullptr, bool recover=true)

Referenced by libvisio::VSDXMetaData::parse(), libvisio::VSDXTheme::parse(), libvisio::VDXParser::processXmlDocument(), libvisio::VSDXParser::processXmlDocument(), and libvisio::VSDXRelationships::VSDXRelationships().